###########################################################################
# Copyright (c) 2000 by Gaeil Ahn                                	  #
# Everyone is permitted to copy and distribute this software.		  #
# Please send mail to fog1@ce.cnu.ac.kr when you modify or distribute     #
# this sources.								  #
###########################################################################

#############################################################
#                                                           #
#     File: File for CR-LSP                                 #
#     Author: Gaeil Ahn (fog1@ce.cnu.ac.kr), June 2000      #
#                                                           #
#############################################################

###########################################################################
#         Adapted to ns-2.1b8 by Christian.Glomb@siemens.com              #
#         If you have problems, found bugs or know improvements,          #
#         please e-mail me (cc to Gaeil Ahn and Haobo Yu).                #
#         Thanks, Christian.                                              #
###########################################################################

# CR-LSP

RtModule/MPLS instproc cbq-installed {} {
	$self instvar classifier_ 
	$classifier_ set is_cbq_installed_ 1
}

RtModule/MPLS instproc set-flow-prio {fec phb prio} {
        $self instvar classifier_
        $classifier_ pft-append-prio $fec $phb $prio
}

RtModule/MPLS instproc set-cbq-okborrow {okborrow} {
	$self instvar cbq_okborrow_     
	$self set cbq_okborrow_ $okborrow
}

RtModule/MPLS instproc set-cbq-maxidle {maxidle} {
	$self instvar cbq_maxidle_
	$self set cbq_maxidle_ $maxidle
}

RtModule/MPLS instproc set-cbq-extradelay {extradelay} {
	$self instvar cbq_extradelay_
	$self set cbq_extradelay_ $extradelay
}

RtModule/MPLS instproc set-cbq-qtype {cbq_qtype} {
	$self instvar cbq_qtype_
	$self set cbq_qtype_ $cbq_qtype
}

RtModule/MPLS instproc get-cbq-okborrow {} {
	$self instvar cbq_okborrow_
	return [$self set cbq_okborrow_]
}

RtModule/MPLS instproc get-cbq-maxidle {} {
	$self instvar cbq_maxidle_
	return [$self set cbq_maxidle_]
}

RtModule/MPLS instproc get-cbq-extradelay {} {
	$self instvar cbq_extradelay_     
	return [$self set cbq_extradelay_]
}

RtModule/MPLS instproc get-cbq-qtype {} {
	$self instvar cbq_qtype_
	return [$self set cbq_qtype_]
}

RtModule/MPLS instproc cbq-resume {} {
	set ldpagents [lsort [$self get-ldp-agents]]
	for {set i 0} {$i < [llength $ldpagents]} {incr i 1} {
		set ldpagent [lindex $ldpagents $i]
		set nexthop [$ldpagent peer-ldpnode]
		if { [$self get-nexthop $nexthop] == $nexthop } {
			set link_ptr [$self get-link-ptr $nexthop]
			$link_ptr enable-cbq
		}
	}
}

RtModule/MPLS instproc give-mapinfo-to-user {lspid} {
        if { [is-exist-func notify-erlsp-setup] > -1 } {
		notify-erlsp-setup [$self node] $lspid
        }
}

RtModule/MPLS instproc give-widinfo-to-user {lspid} {
        if { [is-exist-func notify-erlsp-release] > -1 } {
		notify-erlsp-release $self $lspid
        }
}

RtModule/MPLS instproc give-notinfo-to-user {status lspid tr} {
        if { [is-exist-func notify-erlsp-fail] > -1 } {
		notify-erlsp-fail [$self node] $status $lspid $tr
        }
}

RtModule/MPLS instproc get-flowid-for-lspid {lspid} {
	$self instvar classifier_
        return [$classifier_ get-qosid-for-lspid $lspid]
}

RtModule/MPLS instproc get-lspid-for-flowid {qosid} {
	$self instvar classifier_
        return [$classifier_ get-lspid-for-qosid $qosid]
}

RtModule/MPLS instproc pft-append-qosid {fec phb qosid} {
	$self instvar classifier_ 
        return [$classifier_ pft-append-qosid $fec $phb $qosid]
}

RtModule/MPLS instproc erb-append-qosid {lspid qosid} {
	$self instvar classifier_
        return [$classifier_ erb-append-qosid $lspid $qosid]
}


# get a pointer for a link between two nodes, n1 n2
RtModule/MPLS instproc get-link-ptr {nhopid} {
	set ns [Simulator instance]
	set link_ptr [$ns link [[$self node] id] $nhopid]
	return $link_ptr
}

# get a pointer for a link between two nodes, n1 n2
RtModule/MPLS instproc cbq-dump {nhopid} {
	set link_ptr [$self get-link-ptr $nhopid]
	puts "===================== node[[$self node] id] -----> node[$nhopid id] ================="
	$link_ptr display-cbq-pool
	puts "========================================================================="
	puts ""
}

# Traffic_Parameters: Frequency(0), Weight(1), PDR(2), PBS(3), CDR(4), CBS(5), EBS(6) 
RtModule/MPLS instproc trparms-to-bw {tr} {
	if { [string length $tr] < 5 } {
		return -1
	}
	set CDR [msg-index $tr 4 "_"]
	return $CDR
}

# Traffic_Parameters: Frequency(0), Weight(1), PDR(2), PBS(3), CDR(4), CBS(5), EBS(6) 
RtModule/MPLS instproc trparms-to-qlim {tr} {  
	if { [string length $tr] < 5 } {
		return -1
	}
	set CBS [msg-index $tr 5 "_"]
	return $CBS
}

RtModule/MPLS instproc pmtparms-to-sprio {pmt} {

  # pre-emption Parameters: setup-priority, HoldingPriority 
  
  if { [string length $pmt] < 2 } {
       return -1
  }
  
  set SetupPriority [msg-index $pmt 0 "_"]

  return $SetupPriority
}


# pre-emption Parameters: setup-priority, HoldingPriority 
RtModule/MPLS instproc pmtparms-to-hprio {pmt} {
	if { [string length $pmt] < 2 } {
		return -1
	}
	set HoldingPriority [msg-index $pmt 1 "_"]
	return $HoldingPriority
}

# check the QoS request, if fail, then notification-msg is sent to the src
#     return  1 : OK. 
#     return  0 : No QoS request
#     return  -1: Failure
RtModule/MPLS instproc admission-control {src lspid erhop tunnelid tr pmt} {
	set ok 1
	set bw   [$self trparms-to-bw   $tr]
	if { $bw < 0 } {
		# It is not a request for CR-LSP.
		return 0
	}
	
	set hprio   [$self pmtparms-to-hprio $pmt]
	
	if { $hprio < 0 } {
		# error : not specify priority  for the requested CR-LSP.
		set ok -1
	} elseif { $tunnelid > 0 } {
		set nexthop [$self get-outgoing-iface $tunnelid]
		set link_ptr [$self get-link-ptr $nexthop]
		# $link_ptr display-cbq-pool
		set flowid  [$self get-flowid-for-lspid  $tunnelid]
		set tunnel_bw [$link_ptr get-info-in-cbq-pool $flowid "bw"]
		
		if { $bw > $tunnel_bw } {
			set ok -1
		}
	} else {
		set nexthop [$self get-nexthop $erhop]
		set link_ptr [$self get-link-ptr $nexthop]
		set usable_bw [$link_ptr get-usable-bw]
		
		if { $bw > $usable_bw } {
			# pre-empt other LSPs with lower priority
			set sprio   [$self pmtparms-to-sprio $pmt] 
			set ok [$self admission-control-using-pmt $nexthop $sprio $bw]
		} else {
			$link_ptr set-usable-bw [expr [bw_parse $usable_bw] - [bw_parse $bw]]
		}
	}
	
	if { $ok == -1 } {
		set nexthop [$self get-nexthop $erhop]
		set link_ptr [$self get-link-ptr $nexthop]
		set usable_bw [$link_ptr get-usable-bw]
		set ldpagent [$self get-ldp-agent $src]
		if { $ldpagent != ""} {
			$ldpagent new-msgid
			$ldpagent send-ex-notification-msg "RcUnavailable" -1 $lspid $tr
		} else {
			# This is a ingress LSR
			#
			$self give-notinfo-to-user "RcUnavailable" $lspid $tr
		}
	}
	
	return $ok
}

# select pre-emptable lsps(flowids), recalculate $usable_bw, and release the lsps
# If Ok return 1, else return -1
RtModule/MPLS instproc admission-control-using-pmt {nexthop sprio neededbw} {
	set link_ptr  [$self get-link-ptr $nexthop]
	set usable_bw [$link_ptr get-usable-bw]
	set victim_flowids [$link_ptr select-victims-basedon-prio $sprio [expr $neededbw - $usable_bw]]
	
	if { $victim_flowids == -1} {
		return -1
	} else {
		set pmtbw 0
		for {set i 0} {$i < [llength $victim_flowids]} {incr i 1} {
			set vt_fid [lindex $victim_flowids $i]
			set pmtbw [expr $pmtbw + [$link_ptr get-info-in-cbq-pool $vt_fid "bw"]]
		}
		
		if { [expr $usable_bw - $neededbw + $pmtbw] >= 0} {
			for {set i 0} {$i < [llength $victim_flowids]} {incr i 1} {
				set lspid [$self get-lspid-for-flowid $vt_fid]
				
				# send RELEASE message to downstream LSRs (RFC 3212)
				$self ldp-trigger-by-release -1 $lspid
				
				# send WITHDRAW message to upstream LSRs (RFC 3212)
				if {[$self get-fec-for-lspid $lspid] > 0} {
					$self ldp-trigger-by-withdraw -1 $lspid
				}
			}
			
			# recalculate the usable-bw
			$link_ptr set-usable-bw [expr [bw_parse $usable_bw] - [bw_parse $neededbw] + [bw_parse $pmtbw]]
			return 1
		} else {
			return -1
		}
	}
}

RtModule/MPLS instproc fail-admission-control {src tr} {
#
# It means that it is failed a try to establish a CR-LSP using CR-Request Message
#      - recalculate usable_bw_
#     return  1 : OK. 
#     return  0 : No QoS request

      set bw   [$self trparms-to-bw   $tr]

      if { $bw < 0 } {
          # It is not the request for a CR-LSP.
          return 0
      }
      
      set link_ptr [$self get-link-ptr $src]
      set usable_bw [$link_ptr get-usable-bw]
           
      $link_ptr set-usable-bw [expr [bw_parse $usable_bw] + [bw_parse $bw]]

      return 1       
}



RtModule/MPLS instproc resource-reservation {nhopid tr hprio flowid} {
#
# allocate the requested resource
#     return >= 0 : flowid
#     return -1  : It's not the QoS request.

	set bw   [$self trparms-to-bw   $tr]
	
	if { $bw < 0 } {
		# It is not the request for a CR-LSP.
		return -1
	}
	
	set qlim [$self trparms-to-qlim $tr]
	set link_ptr [$self get-link-ptr $nhopid]
	
	set parent  [$link_ptr set cbq_rts_root_]
	
	set cbq_qtype  [$self get-cbq-qtype]
	set okborrow   [$self get-cbq-okborrow]
	set maxidle    [$self get-cbq-maxidle]
	set extradelay [$self get-cbq-extradelay]
	
	$link_ptr alloc-resource $flowid $bw $qlim $parent $cbq_qtype $okborrow $hprio $maxidle $extradelay
	
	# $link_ptr display-cbq-pool
	
	return $flowid
}

# release the allocated resource
RtModule/MPLS instproc resource-release {nhopid flowid} {

      if { $flowid < 0 } {
           return  
      }
      set link_ptr [$self get-link-ptr $nhopid]
      
      set cbq_qtype [$self get-cbq-qtype]
      $link_ptr collect-resource $flowid $cbq_qtype
}

RtModule/MPLS instproc make-init-cbq {stype nhop qlim cbq_qtype okborrow bw maxidle priority extradelay flowid} {
	set link_ptr [$self get-link-ptr $nhop]
	$link_ptr make-init-cbq $stype $qlim $cbq_qtype $okborrow $bw $maxidle $priority $extradelay $flowid
}

RtModule/MPLS instproc init-cbq-with-BES {nhop qlim cbq_qtype okborrow bw maxidle priority extradelay flowid} {

      set link_ptr [$self get-link-ptr $nhop]

      $link_ptr init-cbq-with-BES $qlim $cbq_qtype $okborrow $bw $maxidle $priority $extradelay $flowid
}


RtModule/MPLS instproc init-cbq-with-RTS {nhop qlim cbq_qtype okborrow bw maxidle priority extradelay flowid} {

      set link_ptr [$self get-link-ptr $nhop]

      $link_ptr init-cbq-with-RTS $qlim $cbq_qtype $okborrow $bw $maxidle $priority $extradelay $flowid
}

RtModule/MPLS instproc init-cbq-with-STS {nhop qlim cbq_qtype okborrow bw maxidle priority extradelay flowid} {

      set link_ptr [$self get-link-ptr $nhop]

      $link_ptr init-cbq-with-STS $qlim $cbq_qtype $okborrow $bw $maxidle $priority $extradelay $flowid
}

SimpleLink instproc select-victims-basedon-prio {sprio neededbw} {
     #
     # select victims(e.g. flowids) based on the priority and the needed bw, and return them
     #

     $self instvar cbq_pool_flowids_
     
     set victim_list ""
     set robbedbw 0
     
     while { $robbedbw < $neededbw } {
     
            # find flowid with the least prio
            set lowest_prio -1 

            for {set i 0} {$i < [llength $cbq_pool_flowids_]} {incr i 1} {
             
                  set flowid [lindex $cbq_pool_flowids_ $i]
             
                  #            RTS                ST               SBTS              HBTS               
                  if { $flowid == 999  || $flowid == 1000 || $flowid == 1002 || $flowid == 1003 || [lsearch $victim_list $flowid] > -1} {
                       continue
                  }

                  set hprio [$self get-info-in-cbq-pool $flowid "prio"]

                  if { $hprio > $lowest_prio } {
                       set lowest_prio   $hprio
                       set lowest_flowid $flowid
                  }
            }

            if { $lowest_prio == -1 } {
                  return -1
            } elseif { $lowest_prio >= $sprio } {
                  set robbedbw [expr $robbedbw + [$self get-info-in-cbq-pool $lowest_flowid "bw"]]
                  set victim_list [msg-append $victim_list $lowest_flowid " "]
            } else {
                  return -1
            }
     }
     
     return $victim_list
}


SimpleLink instproc get-link-info-ptr {} {
#
#  get a pointer for a link-info between two nodes, n1 n2
#
    $self instvar link_
    
    return $link_
}


SimpleLink instproc get-link-delay {} {
#
#  get a delay value of a link between two nodes, n1 n2
#

    set linkinfo_ptr [$self get-link-info-ptr]
    
    set delay [$linkinfo_ptr set delay_]"
    set delay [string trim $delay "\""]

    return $delay
}


SimpleLink instproc get-link-bw {} {
#
#  get a bandwidth value of a link between two nodes, n1 n2
#

    set linkinfo_ptr [$self get-link-info-ptr]
    set bw  [$linkinfo_ptr set bandwidth_]"
    set bw  [string trim $bw    "\""]

    return $bw
}



SimpleLink instproc get-usable-bw {} {
     $self instvar usable_bw_

     return $usable_bw_
}          


SimpleLink instproc set-usable-bw {newbw} {
     
     $self instvar usable_bw_
     
     set usable_bw_ $newbw
     
     return
}


SimpleLink instproc consume-usable-bw { newbw } {
     
     $self instvar usable_bw_
     
     if { $usable_bw_ >= $newbw } {
     
          set usable_bw_ [expr $usable_bw_ - $newbw]
          
          return  $usable_bw_
     }
     
     return -1
}          



SimpleLink instproc add-cbq-to-cbq-pool {flowid cbqclass cbqqueue} {
     $self instvar cbq_pool_flowids_ cbq_pool_classes_ cbq_pool_queues_

     lappend cbq_pool_flowids_  $flowid
     lappend cbq_pool_classes_  $cbqclass
     lappend cbq_pool_queues_  $cbqqueue
}          


SimpleLink instproc update-flowid-in-cbq-pool {cbqclass flowid} {
     $self instvar cbq_pool_flowids_ cbq_pool_classes_

     set k [lsearch -exact $cbq_pool_classes_ $cbqclass]
     if { $k >= 0 } {
	  set cbq_pool_flowids_ [lreplace $cbq_pool_flowids_ $k $k $flowid]
     }
}


SimpleLink instproc display-cbq-pool {} {
     $self instvar cbq_pool_flowids_ cbq_pool_classes_ cbq_pool_queues_

      puts "   # Resource Status -->> usable-bw = [$self get-usable-bw]"
      for {set i 0} {$i < [llength $cbq_pool_flowids_]} {incr i 1} {
             set flowid [lindex $cbq_pool_flowids_ $i]
             if { $flowid > -1 } {
                  set class  [lindex $cbq_pool_classes_ $i]
                  set queue  [lindex $cbq_pool_queues_  $i]
                  set bw     [$self get-info-in-cbq-pool $flowid "bw"]
                  set prio   [$self get-info-in-cbq-pool $flowid "prio"]
                  set qlim   [$queue set limit_]
                 
                  puts "   >[expr $i +1] : flowid=$flowid: cbqclass=$class  queue=$queue bw=$bw prio=$prio qlim=$qlim"
             }
      }
}


SimpleLink instproc get-class-in-cbq-pool {flowid} {
     $self instvar cbq_pool_flowids_ cbq_pool_classes_

     set k [lsearch -exact $cbq_pool_flowids_ $flowid]
     
     if { $k >= 0 } {
               set cbqclass [lindex $cbq_pool_classes_ $k]
               return $cbqclass
     } else {
               return -1
     }
}


SimpleLink instproc get-flowid-in-cbq-pool {cbqclass} {
     $self instvar cbq_pool_flowids_ cbq_pool_classes_

     set k [lsearch -exact $cbq_pool_classes_ $cbqclass]
     if { $k >= 0 } {
               set flowid [lindex $cbq_pool_flowids_ $k]
               return $flowid
     } else {
               return -1
     }
}


SimpleLink instproc get-queue-in-cbq-pool {cbqclass} {
     $self instvar cbq_pool_queues_ cbq_pool_classes_

     set k [lsearch -exact $cbq_pool_classes_ $cbqclass]
     if { $k >= 0 } {
               set queue [lindex $cbq_pool_queues_ $k]
               return $queue
     } else {
               return -1
     }
}


SimpleLink instproc set-queue-in-cbq-pool {cbqclass newQ} {
     $self instvar cbq_pool_queues_ cbq_pool_classes_

     set k [lsearch -exact $cbq_pool_classes_ $cbqclass]
     if { $k >= 0 } {
               set cbq_pool_queues_ [lreplace $cbq_pool_queues_ $k $k $newQ]

     } else {
               return -1
     }
}



SimpleLink instproc get-info-in-cbq-pool {flowid type} {
     $self instvar cbq_pool_flowids_ cbq_pool_classes_

     set cbqclass [$self get-class-in-cbq-pool $flowid]

     if {$cbqclass == -1} {
        return -1;
     }
      
     switch $type {
                     bw  {   
                           set cbqclass_bw [$cbqclass allot]
                           set link_bw     [$self get-link-bw]
                           return [expr $cbqclass_bw * $link_bw]
                     }
                     
                     prio {
                           return [$cbqclass set priority_]
                     }
                     
                     qlim {
                           set queue [$self get-queue-in-cbq-pool $cbqclass]
                           return [$queue set limit_]
                     }
     }
}



SimpleLink instproc make-init-cbq {stype qlim cbq_qtype okborrow bw maxidle priority extradelay flowid} {
     $self instvar cbq_root_ cbq_bes_root_ cbq_rts_root_ cbq_st_root_
#
# create a CBQ and define a class for Best Effort service

     if { $cbq_root_ == "nil"} {
          set rootClass [new CBQClass]
          $rootClass setparams none 0 1.0 auto 0 3 0
          $self insert $rootClass
     
          $self set cbq_root_ $rootClass
          
     } else {
          set rootClass $cbq_root_
     }
     
     if { ($stype != "SBTS" && $stype != "HBTS") || ($cbq_bes_root_ == "nil") } {
           set default_buckets_of_SFQ [expr $qlim * 10]
           set cbqqueue [$self create-cbqqueue $qlim $cbq_qtype $default_buckets_of_SFQ]
           set level  2
           set cbqclass [$self create-cbqclass $cbqqueue $rootClass $okborrow $bw $maxidle $priority $level $extradelay $flowid]
     }

     switch $stype {
     
            SBTS { # CBQ for Simple Best-effort Traffic Service
                    
                   if { $cbq_bes_root_ == "nil" } {
                         $self set cbq_bes_root_  $cbqclass
                   }
            
                   set level  1
                   set parent $cbq_bes_root_
                   set default_buckets_of_SFQ $qlim
                   incr flowid 1
                   
                   set cbqqueue [$self create-cbqqueue $qlim $cbq_qtype $default_buckets_of_SFQ]
                   set cbqclass [$self create-cbqclass $cbqqueue $parent $okborrow $bw $maxidle $priority $level $extradelay $flowid]
                   $self add-cbq-to-cbq-pool $flowid $cbqclass $cbqqueue
                   return
                }
            HBTS { # CBQ for High-priority Best-effort Traffic Service
                    
                   if { $cbq_bes_root_ == "nil" } {
                         $self set cbq_bes_root_  $cbqclass
                   }
            
                   set level  1
                   set parent $cbq_bes_root_
                   set default_buckets_of_SFQ $qlim
                   incr flowid 2
                   
                   set cbqqueue [$self create-cbqqueue $qlim $cbq_qtype $default_buckets_of_SFQ]
                   set cbqclass [$self create-cbqclass $cbqqueue $parent $okborrow $bw $maxidle $priority $level $extradelay $flowid]
                   $self add-cbq-to-cbq-pool $flowid $cbqclass $cbqqueue
                   return
                }
            RTS {  # CBQ for Real-time Service
            
                   $self set cbq_rts_root_  $cbqclass
                   set total_bw [$self get-link-bw]
                   $self set usable_bw_ [expr $total_bw * $bw]
                   return
                }
            STS {  # CBQ for Signaling Traffic Service
            
                   $self set cbq_st_root_  $cbqclass
                   $self add-cbq-to-cbq-pool $flowid $cbqclass $cbqqueue
                   return
                }
            default { 
                  puts "error: unknown class $stype" 
                  exit 1
                }
     }
}




SimpleLink instproc create-cbqqueue {qlim cbq_qtype buckets} {
#
#  create a cbq-class
#    
    set newQ [new Queue/$cbq_qtype]

    if { $cbq_qtype == "SFQ" } {
        #$newQ set maxqueue_ [expr $qlim +1]
        $newQ set limit_ $buckets
        #$newQ set maxqueue_ $buckets
        #$newQ set buckets_  $buckets
    } else {
        $newQ set limit_ [expr $qlim + 1]
    }
    
    return $newQ
}



SimpleLink instproc enable-cbq {} {

     $self instvar cbq_pool_flowids_ cbq_pool_classes_ cbq_pool_queues_

      for {set i 0} {$i < [llength $cbq_pool_flowids_]} {incr i 1} {
             
             set flowid [lindex $cbq_pool_flowids_ $i]
             set class  [lindex $cbq_pool_classes_ $i]
             set queue  [lindex $cbq_pool_queues_  $i]
             
             if {$flowid > -1} {
                 # $queue reset
                  $queue set blocked_           true
                  $queue set unblock_on_resume_ true
                 
                 set bw      [$class allot]
                 set qlim    [$queue set limit_]
                 set block  [$queue set blocked_]
                 set resume [$queue set unblock_on_resume_]
                 
                 #puts ">>> flowid=$flowid : bw=$bw qlim=$qlim block=$block resume=$resume"

             }
      }
}



SimpleLink instproc create-cbqclass {newQ parent okborrow bw maxidle priority level extradelay flowid} {
#
#  create a cbq-class
#    
    
    set newClass [new CBQClass]

    # parameters for setparams : parent okborrow bandwidth maxidle priority(0-10) level extradelay
    #
    $newClass setparams $parent $okborrow $bw $maxidle $priority $level $extradelay

    $newClass install-queue $newQ
    
    $self insert $newClass

    $self bind  $newClass $flowid
    
    return $newClass
}


SimpleLink instproc alloc-resource {flowid bw qlim parent cbq_qtype okborrow priority maxidle extradelay} {
#
# alloc a requested resource in terms of bandwidth and delay
#        - if ok, return  flowid
#          else   return -1 

     set link_bw [$self get-link-bw]
     set bw      [expr double($bw) / $link_bw]

     set level 1
     
     set cbqclass [$self get-class-in-cbq-pool -1]

     if {$cbqclass == -1} {
         #
         # create new cbq class

         set default_buckets_of_SFQ 1
         set cbqqueue [$self create-cbqqueue $qlim $cbq_qtype $default_buckets_of_SFQ]

         set cbqclass [$self create-cbqclass $cbqqueue $parent $okborrow $bw $maxidle $priority $level $extradelay $flowid]

         $self add-cbq-to-cbq-pool $flowid $cbqclass $cbqqueue
     } else {
         #
         # reuse the existing cbq class of the cbq-pool
         
         set default_buckets_of_SFQ 1
         $self CBQ-set-qlim $cbqclass $cbq_qtype $qlim $default_buckets_of_SFQ
         $cbqclass CBQ-set-parameter $okborrow $bw $maxidle $priority $extradelay

         $self CBQ-change-flowid         $cbqclass $flowid
         $self update-flowid-in-cbq-pool $cbqclass $flowid
     }

     return $flowid
}


SimpleLink instproc collect-resource {flowid cbq_qtype} {
     $self instvar usable_bw_

     set cbqclass [$self get-class-in-cbq-pool $flowid]

     if { $cbqclass == -1 } {
          return
     }
     
     set link_bw     [$self get-link-bw]
     set extra_bw    [$self set usable_bw_]
     set cbqclass_bw [$cbqclass allot]
     
     $self set usable_bw_ [expr $extra_bw + $cbqclass_bw * $link_bw]
    
     
     # option: cbqclass bw okborrow maxidle prio xdelay
     $cbqclass CBQ-set-parameter  0.0 ignore ignore ignore ignore
     
     set oldqueue [$self get-queue-in-cbq-pool $cbqclass]
     $oldqueue reset

     $self CBQ-change-flowid         $cbqclass -1
     $self update-flowid-in-cbq-pool $cbqclass -1
}



SimpleLink instproc CBQ-set-qlim  {cbqclass cbq_qtype qlim buckets} {

    set queue [$self get-queue-in-cbq-pool $cbqclass]
    
    if { $cbq_qtype == "SFQ" } {
        $queue set maxqueue_ [expr $qlim + 1]
        $queue set buckets_  $buckets
    } else {
        $queue set limit_ [expr $qlim + 1 ]
    }
   
}



###############################################################
#
# CBQClass
#
#     CBQ-set-parameter {okborrow bw maxidle prio xdelay}
#
#
###############################################################

###############################################################
#
# option: ignore means "don't care"
#
###############################################################
CBQClass instproc CBQ-set-parameter {okborrow bw maxidle prio xdelay} {

     if { $okborrow != "ignore" } {
          $self set okborrow_ $okborrow
     }
     if { $bw != "ignore" } {
          $self newallot $bw
     }
     if { $maxidle != "ignore" } {
          $self set maxidle_ $maxidle
     }
     if { $prio != "ignore" } {
          $self set priority_ $prio
     }
     if { $xdelay != "ignore" } {
          $self set extradelay_ $xdelay
     }
} 


###############################################################
#
# CBQLink
#
#     CBQ-change-flowid {cbq_class flowid}
#
#
###############################################################

##########################################################
#
# CBQLink Class -superclass SimpleLink
#
###########################################################

CBQLink instproc CBQ-change-flowid {cbq_class flowid} {
	$self instvar classifier_
	
	set slot [$classifier_ findslot $cbq_class]
	set old_flowid [$self get-flowid-in-cbq-pool $cbq_class]
	
	$classifier_ del-hash 0 0 $old_flowid
	$classifier_ install $slot $cbq_class
	$classifier_ set-hash auto 0 0 $flowid $slot
}

Simulator instproc cfg-cbq-on-all-mpls-nodes {sbts_bw hbts_bw rt_bw st_bw} {
        if { $sbts_bw > 0 } {
                $self cfg-cbq-for-SBTS 100 DropTail 1 $sbts_bw  auto 0
        }
        if { $hbts_bw > 0 } {
                $self cfg-cbq-for-HBTS 100 DropTail 1 $hbts_bw  auto 0
        }
        if { $rt_bw > 0 } {
                $self cfg-cbq-for-RTS 40 DropTail  0 $rt_bw  auto 0
        }
        if { $st_bw > 0 } {
                $self cfg-cbq-for-STS 40 DropTail  1 $st_bw  auto 0
        }
	
        if { $st_bw > 0 } {
		$self bind-ldp-to-STS
        } elseif { $hbts_bw > 0 } {
		$self bind-ldp-to-HBTS
        } elseif { $sbts_bw > 0 } {
		$self bind-ldp-to-SBTS
        }
}

# create cbqs for Simple Best-effort Service on all mpls nodes
Simulator instproc cfg-cbq-for-SBTS {qlim cbq_qtype okborrow bw maxidle extradelay} {
        set base_fid   1001
        set priority   9
        set service    SBTS
        
        $self initialize-cbq $service $qlim $cbq_qtype $okborrow $bw $maxidle $priority $extradelay $base_fid
}

# create cbqs for High-priority best-effort service on all mpls nodes
Simulator instproc cfg-cbq-for-HBTS {qlim cbq_qtype okborrow bw maxidle extradelay} {
        set base_fid   1001
        set priority   8
        set service    HBTS
	
        $self initialize-cbq $service $qlim $cbq_qtype $okborrow $bw $maxidle $priority $extradelay $base_fid
}

# create cbqs for signalling traffic on all mpls nodes
Simulator instproc cfg-cbq-for-STS {qlim cbq_qtype okborrow bw maxidle extradelay} {
        set base_fid    1000
        set priority    7
        set service     STS
	
        $self initialize-cbq $service $qlim $cbq_qtype $okborrow $bw $maxidle $priority $extradelay $base_fid
}

# create cbqs for real-time service on all mpls nodes
Simulator instproc cfg-cbq-for-RTS {qlim cbq_qtype okborrow bw maxidle extradelay} {	
        set base_fid    999
        set priority    7
        set service     RTS
	
        $self initialize-cbq $service $qlim $cbq_qtype $okborrow $bw $maxidle $priority $extradelay $base_fid
        $self set-params-for-RTS $cbq_qtype $okborrow $maxidle $extradelay
}

Simulator instproc initialize-cbq {stype qlim cbq_qtype okborrow bw maxidle priority extradelay basefid} {
        $self instvar linked_mplsnodes_
        
        # create cbqs for signalling traffic on all mpls nodes
	
        set len [llength $linked_mplsnodes_]
	
        for {set i 0} {$i < $len} {incr i} {
		set me [lindex $linked_mplsnodes_ $i]
		for {set k $i} {$k < $len} {incr k} {
			set peer [lindex $linked_mplsnodes_ $k]
			if { [lsearch [$me set neighbor_] $peer] > -1 } {
				if { [$me is-neighbor $peer] == 1 } {
					set memod   [$me   get-module "MPLS"]
					set peermod [$peer get-module "MPLS"]
					$memod   make-init-cbq $stype $peer $qlim $cbq_qtype $okborrow $bw $maxidle $priority $extradelay $basefid
					$peermod make-init-cbq $stype $me   $qlim $cbq_qtype $okborrow $bw $maxidle $priority $extradelay $basefid
					$memod   cbq-installed
					$peermod cbq-installed
				}
			}
		}
        }
}

Simulator instproc bind-ldp-to-BES {} {
        $self bind-flowid-to-SBTS 991 995
}

Simulator instproc bind-ldp-to-SBTS {} {
        $self bind-flowid-to-SBTS 991 995
}

Simulator instproc bind-ldp-to-HBTS {} {
        $self bind-flowid-to-HBTS 991 995
}

Simulator instproc bind-ldp-to-STS {}  {
        $self bind-flowid-to-STS 991 995
}

Simulator instproc bind-flowid-to-STS {a args} {
        set basefid 1000
	if { [llength $args] == 1 } {
		$self bind-flowid-to-cbq $basefid $a $args
	} else {
		$self bind-flowid-to-cbq $basefid $a $a
	}
}

Simulator instproc bind-flowid-to-SBTS {a args} {
        set basefid 1002
	if { [llength $args] == 1 } {
		$self bind-flowid-to-cbq $basefid $a $args
	} else {
		$self bind-flowid-to-cbq $basefid $a $a
	}
}

Simulator instproc bind-flowid-to-HBTS {a args} {
        set basefid 1003
	if { [llength $args] == 1 } {
		$self bind-flowid-to-cbq $basefid $a $args
	} else {
		$self bind-flowid-to-cbq $basefid $a $a
	}
}

Simulator instproc bind-flowid-to-cbq {basefid a b} {
        $self instvar linked_mplsnodes_
        set len [llength $linked_mplsnodes_]
	
        for {set i 0} {$i < $len} {incr i} {
		set me [lindex $linked_mplsnodes_ $i]
		for {set k $i} {$k < $len} {incr k} {
			set peer [lindex $linked_mplsnodes_ $k]
			if { [lsearch [$me set neighbor_] $peer] > -1 } {
				if { [$me is-neighbor $peer] == 1 } {
					set memod   [$me   get-module "MPLS"]
					set peermod [$peer get-module "MPLS"]
					
					$memod   bind-flowid-to-cbq $basefid $a $b $peer
					$peermod bind-flowid-to-cbq $basefid $a $b $me
				}
			}
		}
        }
}

RtModule/MPLS instproc refresh-RTS-cbq {nhop} {
	set link_ptr [$self get-link-ptr $nhop]
	set flowids [$link_ptr set cbq_pool_flowids_]
	
	for {set i 0} {$i < [llength $flowids]} {incr i 1} {	
		set flowid [lindex $flowids $i]
		if { $flowid >= 1010 } {
			set cbqclass [$link_ptr get-class-in-cbq-pool $flowid]
			$link_ptr bind  $cbqclass $flowid
		}
	}
}

RtModule/MPLS instproc bind-flowid-to-cbq {basefid a b nhop} {
	set link_ptr [$self get-link-ptr $nhop]
	set cbqclass [$link_ptr get-class-in-cbq-pool $basefid]
	$link_ptr bind  $cbqclass $a $b
}

RtModule/MPLS instproc bind-ldp-to-BES {nhop} {
        $self bind-flowid-to-SBTS 991 995 $nhop
}

RtModule/MPLS instproc bind-ldp-to-SBTS {nhop} {
        $self bind-flowid-to-SBTS 991 995 $nhop
}

RtModule/MPLS instproc bind-ldp-to-HBTS {nhop} {
        $self bind-flowid-to-HBTS 991 995 $nhop
}

RtModule/MPLS instproc bind-ldp-to-STS {nhop}  {
        $self bind-flowid-to-STS 991 995 $nhop
}

RtModule/MPLS instproc bind-flowid-to-BTS {a b nhop} {
        set basefid 1002
	$self bind-flowid-to-cbq $basefid $a $b $nhop
}

RtModule/MPLS instproc bind-flowid-to-SBTS {a b nhop} {
        set basefid 1002
	$self bind-flowid-to-cbq $basefid $a $b $nhop
}

RtModule/MPLS instproc bind-flowid-to-HBTS {a b nhop} {
        set basefid 1003
	$self bind-flowid-to-cbq $basefid $a $b $nhop
}

RtModule/MPLS instproc bind-flowid-to-STS {a b nhop} {
        set basefid 1000
	$self bind-flowid-to-cbq $basefid $a $b $nhop
}

Simulator instproc set-params-for-RTS {cbq_qtype okborrow maxidle extradelay} {
	$self instvar linked_mplsnodes_
	set mplslen [llength $linked_mplsnodes_]
	
	for {set k 0} {$k < $mplslen} {incr k} {
		# select a mpls-node
		set me [lindex $linked_mplsnodes_ $k]
		set memod [$me get-module "MPLS"]
		
		$memod set-cbq-qtype      $cbq_qtype
		$memod set-cbq-okborrow   $okborrow
		$memod set-cbq-maxidle    $maxidle
		$memod set-cbq-extradelay $extradelay
	}
}

### Local Variables:
### mode: tcl
### tcl-indent-level: 8
### tcl-default-application: ns
### End:
